"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.default = exports.registerModel = exports.query = exports.start = exports.init = void 0;

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _hooks = require("@forrestjs/hooks");

var hooks = _interopRequireWildcard(require("./hooks"));

var _init = _interopRequireDefault(require("./init"));

exports.init = _init.default;

var _start = _interopRequireDefault(require("./start"));

exports.start = _start.default;

var _conn = require("./conn");

exports.getHandler = _conn.getHandler;
exports.getModel = _conn.getModel;
exports.resetModels = _conn.resetModels;
exports.registerModel = _conn.registerModel;

var _query = _interopRequireDefault(require("./query"));

exports.query = _query.default;

function _createForOfIteratorHelperLoose(o, allowArrayLike) { var it; if (typeof Symbol === "undefined" || o[Symbol.iterator] == null) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; return function () { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } it = o[Symbol.iterator](); return it.next.bind(it); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }

var _default = ({
  registerHook,
  registerAction,
  createHook
}) => {
  registerHook(hooks);
  registerAction({
    hook: _hooks.INIT_SERVICE,
    name: hooks.SERVICE_NAME,
    trace: __filename,
    handler: function () {
      var _handler = (0, _asyncToGenerator2.default)(function* ({
        getConfig,
        setContext,
        getContext
      }, ctx) {
        const connections = getConfig('postgres.connections'); // Let features hook into the existing connections configuration

        createHook.sync(hooks.POSTGRES_BEFORE_INIT, {
          connections
        });

        for (var _iterator = _createForOfIteratorHelperLoose(connections), _step; !(_step = _iterator()).done;) {
          const options = _step.value;

          // #18 apply defaults to the models list
          if (!options.models) {
            options.models = [];
          }

          const connName = options.connectionName || 'default';
          createHook.sync(`${hooks.POSTGRES_BEFORE_INIT}/${connName}`, {
            options
          });
          yield (0, _init.default)(options, ctx);
          createHook.sync(`${hooks.POSTGRES_AFTER_INIT}/${connName}`, {
            options
          });
        } // Decorate the context with the PG context


        setContext('pg', {
          query: _query.default,
          getModel: _conn.getModel,
          getHandler: _conn.getHandler,
          resetModels: _conn.resetModels
        });
        createHook.sync(hooks.POSTGRES_AFTER_INIT, Object.assign({}, getContext('pg'), {
          connections
        }));
      });

      function handler(_x, _x2) {
        return _handler.apply(this, arguments);
      }

      return handler;
    }()
  });
  registerAction({
    hook: _hooks.START_SERVICE,
    name: hooks.SERVICE_NAME,
    trace: __filename,
    handler: function () {
      var _handler2 = (0, _asyncToGenerator2.default)(function* ({
        getConfig,
        getContext
      }, ctx) {
        const connections = getConfig('postgres.connections');
        yield createHook.serie(hooks.POSTGRES_BEFORE_START, Object.assign({}, getContext('pg'), {
          connections
        }));

        for (var _iterator2 = _createForOfIteratorHelperLoose(connections), _step2; !(_step2 = _iterator2()).done;) {
          const options = _step2.value;
          const connName = options.connectionName || 'default';
          createHook.serie(`${hooks.POSTGRES_BEFORE_START}/${connName}`, Object.assign({}, getContext('pg'), {
            registerModel: model => options.models.push(model)
          }));
          yield (0, _start.default)(options, ctx);
          createHook.serie(`${hooks.POSTGRES_AFTER_START}/${connName}`, Object.assign({}, getContext('pg'), {
            handler: (0, _conn.getHandler)(connName)
          }));
        }

        yield createHook.serie(hooks.POSTGRES_AFTER_START, Object.assign({}, getContext('pg'), {
          connections
        }));
      });

      function handler(_x3, _x4) {
        return _handler2.apply(this, arguments);
      }

      return handler;
    }()
  });
};

exports.default = _default;